/*!
 * donutgraph.js 1.0.0
 * https://github.com/jpweinerdev/donutgraph.js
 *
 * @license MIT (https://github.com/jpweinerdev/donutgraph.js/blob/master/LICENSE)
 *
 * @copyright 2021 http://developer.jpweiner.net/donutgraph.html - A project by Jean-Pierre Weiner - Developer
 */(function(a,b,c,e){"use strict";var d=Math.min;function f(b,c){var d=this;this.element=b,this.settings=a.extend({},g,c),this._defaults=g,this._name="donutgraph",this.update=function(a){d.settings.data=a,d.drawAndUpdate()},this.setColor=function(a){d.setColorByIndex(a)},this.init()}var g={container:"#graph",measureElement:"#measure",width:400,height:400,donutWidth:20,padAngle:.02,animationDuration:750,labelColor:"#9e9e9e",accentColor:["#d81b60","#80c441"],colorSetting:["#33876b","#559559","#77a347","#98b236","#bac024","#dcce12","#e0e0e0"],useColorRange:!0},h={updateGraphSettings:function(a){"object"==typeof a&&(this.graph.settings.container=a.container,this.graph.settings.measureElement=a.measureElement,this.graph.settings.width=a.width,this.graph.settings.height=a.height,this.graph.settings.donutWidth=a.donutWidth,this.graph.settings.padAngle=a.padAngle,this.graph.settings.animationDuration=a.animationDuration,this.graph.settings.labelColor=a.labelColor,this.graph.settings.accentColor=a.accentColor,this.graph.settings.colorSetting=a.colorSetting,this.graph.settings.useColorRange=a.useColorRange)},graph:{svg:{},pie:{},arc:{},infoData:[],settings:{container:"#graph",measureElement:"#measure",width:0,height:0,donutWidth:0,padAngle:0,animationDuration:0,labelColor:"",accentColor:[],colorSetting:[],useColorRange:!0},setColor:function(a,b){var c=this.settings.colorSetting;return Object.hasOwn(a.data,"color")?a.data.color:b<c.length?this.settings.useColorRange?c[b]:c[0]:c[c.length-1]},setColorByIndex:function(a){var b=this.settings.accentColor;return 0>a||a>b.length-1?(console.log("Out of color range!"),b[0]):b[a]},initDonutGraph:function(){var b=this.settings.width,c=this.settings.height,f=d(b,c)/2,g=f-50-this.settings.donutWidth;e.select("body").append("span").attr("id",this.settings.measureElement.substring(1)).style("position","absolute").style("left","-11000px"),a(this.settings.container).empty(),this.svg=e.select(this.settings.container).append("svg").attr("width",this.settings.width).attr("height",this.settings.height).append("g").attr("id","donutg").attr("transform","translate("+b/2+","+c/2+")"),this.pie=e.pie().value(function(a){return a.value}).padAngle(this.settings.padAngle).sort(null),this.arc=e.arc().innerRadius(g).outerRadius(f-50).padAngle(this.settings.padAngle)},refreshDonutGraph:function(b){var c=Math.PI,f=Math.round,g=this,h=null,i=this.settings.animationDuration,j=this.settings.width,k=this.settings.height,m=d(j,k)/2-50,b=b||[];b=b.sort(function(c,a){return e.descending(c.value,a.value)}),this.infoData=[];var n=this.arc,o=this.svg,p=this.pie,q=o.selectAll("path"),r=q.data(),s=p(b);q=o.selectAll("path").data(s);var t=e.format(",d"),u=0;s.forEach(function(a){u+=a.value});var v=function(a,b){var c=a.data.label,d=t(a.value),e=f(100*(a.value/u),2)+"%";return g.infoData.push({id:b,label:c,value:a.value,valueFormated:d,percent:e}),c+"\nItems: "+d+"\n"+e},w=function(a,b,c){var e;return(e=x(a,b,c))?{startAngle:e.endAngle,endAngle:e.endAngle}:null},x=function(a,b){for(var c=b.length;0<=--a;)if(a+1==c)return b[a]},y=function(a){var b=e.interpolate(this._current,a);return this._current=b(0),function(a){return n(b(a))}};q.transition().duration(i).attrTween("d",y),q.enter().append("path").attr("d",n).each(function(a,b){this._current=w(b,r,s)||a}).attr("class","donut").attr("id",function(a,b){return"tArc_"+b}).style("opacity",0).attr("fill",function(a,b){return g.setColor(a,b)}).merge(q).transition().duration(i).attr("fill",function(a,b){return g.setColor(a,b)}).style("opacity",1).attrTween("d",y).on("end",function(){e.selectAll(".textlabel").transition().duration(300).style("opacity",1)}),0==b.length?q.exit().datum(function(a,b){return w(b,s,r)||a}).transition().duration(i).style("opacity",0).remove():q.exit().datum(function(a,b){return w(b,s,r)||a}).transition().duration(i).attrTween("d",y).remove(),o.selectAll("title").remove(),o.selectAll("path").data(s).append("title").text(function(a,b){return v(a,b)}),o.selectAll(".textlabel").remove(),h=o.selectAll(".textlabel").data(s),h.enter().append("text").style("opacity",0).attr("class","textlabel").attr("dx",2).attr("dy",-5).attr("fill",g.settings.labelColor).append("textPath").attr("xlink:href",function(a,b){return"#tArc_"+b}).style("text-anchor","left").attr("startOffset",function(a){return 0==a.startAngle&&a.endAngle==2*c?"25.5%":null}).text(function(b,d){var h=100*((b.endAngle-b.startAngle)/c/2),i=b.endAngle-b.startAngle,j=b.data.label.length,k=0,l=0,n=0;return d>g.settings.colorSetting.length&&1>=f(h)?.5<h?".":"":(a("#measure").html(b.data.label),k=e.select(g.settings.measureElement).node().getBoundingClientRect().width,l=i*m,n=j-f(.9*l/(k/j)),f(.9*l)>1*f(k)?b.data.label:b.data.label.substr(0,j-n-3)+"...")}),h.exit().datum(function(a,b){return w(b,s,r)||a}).remove()},changeColorOfGraph:function(a){var b=this.svg,c=this.setColorByIndex(a);b.selectAll(".donut").transition().duration(500).attr("fill",function(){return c})}},init:function(a){this.graph.initDonutGraph(),this.graph.refreshDonutGraph(a)},update:function(a){this.graph.refreshDonutGraph(a)},changeColor:function(a){this.graph.changeColorOfGraph(a)},getValues:function(){return this.graph.infoData}};a.extend(f.prototype,{init:function(){h.updateGraphSettings(this.settings),h.init(),h.update(this.settings.data),this.updateInfo()},drawAndUpdate:function(){h.update(this.settings.data),this.updateInfo()},setColorByIndex:function(a){h.changeColor(a)},updateInfo:function(){"function"==typeof this.settings.onChange&&this.settings.onChange(h.getValues())}}),a.fn.donutgraph=function(b){if("string"==typeof arguments[0]){var c,d=arguments[0],e=Array.prototype.slice.call(arguments,1);return this.each(function(){if(a.data(this,"plugin_donutgraph")&&"function"==typeof a.data(this,"plugin_donutgraph")[d])c=a.data(this,"plugin_donutgraph")[d].apply(this,e);else if("destroy"===d)a.data(this,"plugin_donutgraph",null);else throw new Error("Method "+d+" does not exist on jQuery.donutgraph")}),void 0===c?this:c}return"object"!=typeof b&&b?void 0:this.each(function(){a.data(this,"plugin_donutgraph")||a.data(this,"plugin_donutgraph",new f(this,b))})}})(jQuery,window,document,d3);